<template>
  <q-page class="q-pa-lg">
    
    <q-btn :to="{ name: 'community', params: { idCommunity: idCommunity }}" flat class="q-pa-none">
      <q-icon name="arrow_back" size="sm" />
    </q-btn>

    <h1>{{ time }} Uhr</h1>
    
    <q-list bordered separator>
      <q-item
        v-for="(room, idRoom) in rooms"
        :key="room.id"
        clickable
        :to="{ name: 'room', params: { idCommunity: idCommunity, idTime: idTime, idRoom: idRoom }}"
        style="min-height: 100px;"
      >
        <q-item-section>
          <q-item-label>
            <p class="text-h3 q-mb-none">{{ room.label }}</p>
          </q-item-label>
          <q-item-label>
            <span class="text-weight-thin">
              {{ room.counter }} /
              <span v-if="room.quota == '-1'"> ∞</span>
              <span v-else>{{ room.quota }}</span>
            </span>
          </q-item-label>
        </q-item-section>
        <q-item-section avatar v-if="room.quota != '-1'">
          <q-circular-progress
            show-value
            font-size="12px"
            :value="getProgress(room) * 100"
            size="50px"
            :thickness="0.22"
            :color="getColor(room)"
            track-color="grey-3"
            class="q-ma-md"
          >
            {{ Math.round(room.counter / room.quota * 100) }}%
          </q-circular-progress>
        </q-item-section>
      </q-item>
    </q-list>

  </q-page>
</template>

<script>
import { defineComponent, ref } from "vue";
import { getDatabase, ref as refFb, onValue } from "firebase/database";

export default defineComponent({
  name: "PageTime",
  props: {
    idCommunity: {
      required: true,
    },
    idTime: {
      required: true,
    },
  },
  setup() {
    let time = ref("");
    let rooms = ref([]);

    return {
      time,
      rooms,
    };
  },
  mounted() {
    this.loadTime(this.idCommunity, this.idTime);
  },
  async beforeRouteUpdate(to, from) {
    this.loadTime(to.params.idCommunity, to.params.idTime);
  },
  methods: {
    loadTime(idCommunity, idTime) {

      const db = getDatabase();
      
      const starCountRef = refFb(db, "communities/" + idCommunity + "/times/" + idTime);
      onValue(starCountRef, (snapshot) => {
        const data = snapshot.val();
        this.time = data.label;
        this.rooms = data.rooms;
      });
    },
    getColor(room) {
      var progress = this.getProgress(room) * 100;
      if (progress < 85) return 'green';
      if (progress < 100) return 'orange';
      return 'red';
    },
    getProgress(room) {
      return room.counter / room.quota;
    }
  },
});
</script>
